/**
 * Fichero : data_base.c      Fecha: 04/03/2017
 * 
 *  Implementación del TAD Base de Datos.
 *                                            
 */
#include "data_base.h"
#include "twitteros.h"
#include "tweets.h"
#include "twittero.h"
#include "tweet.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>

struct _data_base {
    twitteros *table_twitteros;
    tweets *table_tweets;
};

/** Estructura para recuperar hashtags y su numero de repeticiones */
typedef struct _hashtag_number {
  char hashtag[140];
  long long int number;
} hashtag_number;

/**
 * Funcion auxiliar para construir una path concatenando el nombre
 * de un directorio y el nombre de un fichero.
 * 
 * Entrada:
 *    El nombre del directorio y del fichero.
 * Salida:
 *    El path construido, que debe liberarse por el llamante.
 */
char *bd_create_path(const char *dirname, const char *filename);

/**
 * Funcion para crear una estructura twittero a partir de un registro de cadena. 
 *
 * Entrada:
 *    Una cadena con campos separados por | según indica el enunciado.

 * Salida:
 *    La estructura TAD twittero con los campos inicializados o NULL en caso de error.
 */
twittero *bd_parse_twittero(char *registro);

/**
 * Funcion para crear una estructura twitteros poblada a partir de un fichero con
 * registros de twitteros.
 *
 * Entrada:
 *    Una cadena con el nombre del fichero. Cada fila del fichero ha de ser como
 *    se define en el enunciado.

 * Salida:
 *    La estructura twitteros con los twitteros o NULL en caso de error.
 */
twitteros *bd_parse_file_twitteros(char *file_name);

/**
 * Funcion para crear una estructura tweet a partir de un registro de cadena. 
 *
 * Entrada:
 *    Una cadena con el campos separados por | según indica el enunciado.
 *
 * Salida:
 *    La estructura del TAD tweet con los campos inicializados o NULL en caso de error.
 */
tweet *bd_parse_tweet(char *registro, twitteros *tts);

/**
 * Funcion para crear una estructura twitteros poblada a partir de un fichero.
 *
 * Entrada:
 *    Una cadena con el nombre del fichero. Cada fila del fichero ha de ser como
 *    se define en el enunciado.

 * Salida:
 *    La estructura twitteros o NULL en caso de error.
 */
tweets *bd_parse_file_tweets(char *file_name, twitteros *tts);

/**=====================================================================
 * 1ª SEMANA
 * ===================================================================*/

data_base *new_data_base(const char *dirname) {
	return NULL;
}

void destroy_data_base(data_base *db) {
    return NULL;
}

twittero *bd_parse_twittero(char *registro) {
    return NULL;
}

twitteros *bd_parse_file_twitteros(char *file_name) {
    return NULL;
}

tweet *bd_parse_tweet(char *registro, twitteros *tts) {
    return NULL;
}

tweets *bd_parse_file_tweets(char *file_name, twitteros *tts) {
    return NULL;
}

char *bd_create_path(const char *dirname, const char *filename) {
    return NULL;
}

/**=====================================================================
 * 2ª y 3ª SEMANA
 * ===================================================================*/

tweet *find_tweet_by_id(data_base * db, long long int id) {
	return NULL;
}

twittero *find_twittero_by_id(data_base * db, long long int id) {
	return NULL;
}

tweet *find_tweet_by_text(data_base *db, char *text) {
    return NULL;
}

twittero *find_twittero_by_alias(data_base *db, char * alias) {
    return NULL;
}

list *find_all_twitteros(data_base *db) {
    return NULL;
}

list *find_all_tweets(data_base *db) {
    return NULL;
}

list *find_hashtags_per_mentioned(data_base *db, char *alias) {
	return NULL;
}

/**=====================================================================
 * 4ª SEMANA
 * ===================================================================*/

BOOL data_base_add_tweet(data_base *db, tweet *t) {
    return NULL;
}

BOOL data_base_add_twittero(data_base *db, twittero *tt) {
    return NULL;
}

BOOL data_base_remove_tweet(data_base *db, tweet *t) {
    return NULL;
}

int data_base_remove_twittero(data_base *db, twittero *tt) {
    return NULL;
}

void dump_data_base(data_base *db) {
	return NULL;
}

