
#ifndef _LIST_H
#define _LIST_H

#include "const.h"

/* typedef struct _list_node *plist_node; */

typedef struct _list_node list_node;
typedef struct _list_node list;

/**
 * Crea una nueva lista.
 */
list * new_list();

/**
 * Elimina la lista, incluyendo todos sus nodos pero
 * no elimina el contenido de cada nodo.
 */
void destroy_list(list *l);

/**
 * Inserta el elemento apuntado por el puntero "data"
 * a continuación del nodo pasado como parámetro.
 */
list_node * list_insert(list_node *node, void *data);

/**
 * Obtiene el dato asociado al nodo pasado como parámetro.
 */
void * list_get_data(list_node *node);

/**
 * Obtiene el primer nodo de una lista, o NULL si
 * si la lista está vacía.
 */
list_node * list_first(list *list);

/**
 * Devuelve el nodo siguiente a un nodo dado,
 * o NULL si no tiene ningún nodo a continuación.
 */
list_node * list_node_next(list_node *node);

/**
 * Devuelve el tamaño de la lista.
 */
int  list_size(list *l);

/**
 * Devuelve TRUE si la lista está vacía o FALSE
 * en caso contrario.
 */
BOOL list_is_empty(list *l);

#endif
